"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultAccountController = void 0;
var teys_injector_1 = require("teys-injector");
var lib_1 = require("../../lib");
var DefaultAccountController = /** @class */ (function (_super) {
    __extends(DefaultAccountController, _super);
    function DefaultAccountController(server, version) {
        if (version === void 0) { version = "v1"; }
        return _super.call(this, server, "account", version) || this;
    }
    DefaultAccountController.prototype.login = function (req, res) {
        return __awaiter(this, void 0, void 0, function () {
            var user, token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!req.body || !req.body.username || !req.body.passsword) {
                            return [2 /*return*/, (0, lib_1.badRequest)(res, { details: "invalid data" })];
                        }
                        return [4 /*yield*/, this.userProvider
                                .validateCredentials(req.body.username, req.body.password)];
                    case 1:
                        user = _a.sent();
                        if (!user) {
                            return [2 /*return*/, (0, lib_1.forbidden)(res, { details: "invalid credentials" })];
                        }
                        if (!user.uuid) {
                            return [2 /*return*/, (0, lib_1.error)(res, { details: "invalid user" })];
                        }
                        return [4 /*yield*/, this.tokenManager.createAuthenticationToken(user.uuid, user.roles)];
                    case 2:
                        token = _a.sent();
                        if (!this.tokenProvider) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.tokenProvider.saveToken(token)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/, (0, lib_1.ok)(res, { detail: "login successful", token: token })];
                }
            });
        });
    };
    DefaultAccountController.prototype.register = function (req, res) {
        return __awaiter(this, void 0, void 0, function () {
            var post, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        post = req.body;
                        if (!post || !post.isValid()) {
                            return [2 /*return*/, (0, lib_1.badRequest)(res, { details: "invalid data" })];
                        }
                        return [4 /*yield*/, this.userProvider.registerUser(post)];
                    case 1:
                        user = _a.sent();
                        return [2 /*return*/, (0, lib_1.ok)(res, user)];
                }
            });
        });
    };
    __decorate([
        (0, teys_injector_1.Inject)(),
        __metadata("design:type", lib_1.JwtTokenManager)
    ], DefaultAccountController.prototype, "tokenManager", void 0);
    __decorate([
        (0, teys_injector_1.Inject)("_class_restuserprovider"),
        __metadata("design:type", lib_1.RestUserProvider)
    ], DefaultAccountController.prototype, "userProvider", void 0);
    __decorate([
        (0, teys_injector_1.Inject)("_class_tokenprovider"),
        __metadata("design:type", lib_1.TokenProvider)
    ], DefaultAccountController.prototype, "tokenProvider", void 0);
    __decorate([
        (0, lib_1.Post)("authenticate"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Promise)
    ], DefaultAccountController.prototype, "login", null);
    __decorate([
        (0, lib_1.Post)("register"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Promise)
    ], DefaultAccountController.prototype, "register", null);
    return DefaultAccountController;
}(lib_1.RestController));
exports.DefaultAccountController = DefaultAccountController;
